#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <conio.h>     /*getch()函数使用的头文件*/
#include <windows.h>  /*Sleep()函数使用的头文件*/
#include <string.h>   /*strcmp()函数使用的头文件*/
#include<assert.h>
 
 
 
 
/*图书结构体：图书编号，图书名，图书作者，出版社，库存量*/
typedef struct Book
{
	int iNum;
	char acName[15];
	char acAuthor[15];
	char acPress[15];
	int iAmount;
	struct Book* next;
}Book;
 
/*读者：读者编号，读者姓名，性别，可借书数,读者已借书的编号*/
typedef struct Reader
{
	int iNum;
	char acName[15];
	char acSex[4];
	char position[20];
	int iMax;         //Student 20本 teacher 40本
	int iAmount;
	int aiBookId[100];
	int balance;
	int day;
	struct Reader* next;
}Reader;
 
 
void ShowLibInfo(const Book* book, const Reader* reader);
void ShowLibBook(Book* book);
Book* AddBook(Book* book);
Book* DealoldBook(Book* book);
void foundBook(Book* book);
void foundReader_Info(Reader* reader);
void foundReaderInfo(Reader* reader);
Reader* LendBook(Reader* reader, Book* book);
void returnBook(Reader* reader, Book* book);
void save(Book* book);
Book* read1();
 
//C1
void ShowMainMenu()
{
	system("cls");
	printf("\n\n\n\n\n");
	printf("\t|----------------------欢迎进入---------------------------\n");
	printf("\t|                    读者管理系统                              \n");
	printf("\t|                  1、查询图书馆的总信息                         \n");
	printf("\t|                  2、查询图书馆藏书信息                          \n");
	printf("\t|                  3、存入新书                                  \n");
	printf("\t|                  4、旧书处理                                  \n");
	printf("\t|                  5、根据书名检索书刊信息                        \n");
	printf("\t|                  6、查询读者的借阅信息                         \n");
	printf("\t|                  7、查询读者信息                              \n");
	printf("\t|                  8、读者借书                                 \n");
	printf("\t|                  9、读者还书                                 \n");
	printf("\t|                  10、文件保存                                 \n");
	printf("\t|                  11、从文件读取                                \n");
	printf("\t|                  0、退出                                     \n");
	printf("\t|---------------------------------------------------------\n");
	printf("新打开程序需先添加管理员\n");
	printf("\n");
	printf("\t\t请选择（0-11）：");
}

//C2
void ShowLibInfo(const Book* book1, const Reader* reader1)
{
    Book* book = book1;
    Reader* reader = reader1;
    int bookNUm = 0, readerNUm = 0, mangerNUm = 0;
    while (book != NULL)
    {
        bookNUm++;
        book = book->next;
    }
    while (reader != NULL)
    {
        readerNUm++;
        reader = reader->next;
    }
    printf("本图书馆共有藏书%d本,读者%d人\n", bookNUm, readerNUm);
    printf("按任意键返回\n");
    getchar();
    return;
}

//C3
void ShowLibBook(Book* book1)
{
    Book* book = book1;
    while (book != NULL)
    {                     // \t :制表符
        printf("%d\t%s\t%s\t%s\t%d\n", book->iNum, book->acName, book->acAuthor, book->acPress, book->iAmount);
        book = book->next;
    }
    printf("\n按任意键返回\n");
    getchar();
    return;
}

//C4
Book* AddBook(Book* book1)
{
    Book* book = book1;
    if (book == NULL)
    {
        Book* tmp = (Book*)malloc(sizeof(Book));
        tmp->next = NULL;
        assert(tmp);
        printf("输入书的编号:");
        scanf("%d", &tmp->iNum);
        getchar();
        printf("输入书的名称:");
        gets(&tmp->acName);
        printf("输入书的作者:");
        gets(tmp->acAuthor);
        printf("输入书的出版社:");
        gets(tmp->acPress);
        printf("输入书的库存量:");
        scanf("%d", &tmp->iAmount);
        book = tmp;
        printf("按任意键返回\n");
        getchar();
        return book;
        return;
    }
    while (1)
    {
        while (book->next == NULL)
        {
            int flag = 1;
            while (flag)
            {
                Book* tmp = (Book*)malloc(sizeof(Book));
                tmp->next = NULL;
                assert(tmp);
                printf("输入书的编号:");
                scanf("%d", &tmp->iNum);
                getchar();
                printf("输入书的名称:");
                gets(&tmp->acName);
                printf("输入书的作者:");
                gets(tmp->acAuthor);
                printf("输入书的出版社:");
                gets(tmp->acPress);
                printf("输入书的库存量:");
                scanf("%d", &tmp->iAmount);
                book->next = tmp;
                printf("是否继续输入:1==>继续\t0==>结束\t");
                scanf("%d", &flag);
                getchar();
                if (flag == 0)
                {
                    printf("按任意键返回\n");
                    getchar();
                    return book1;
                }
            }
        }
        book = book->next;
    }
    printf("按任意键返回\n");
    getchar();
    return;
}
//C5
Book* DealoldBook(Book* book1)
{
    Book* book = book1;
    Book* prev = book1;
    printf("输入要处理旧书的编号:");
    int id;
    scanf("%d", &id);
    getchar();
    while (book != NULL)
    {
        if (id == book->iNum)
        {
            if (book1 == book)
            {
                book = book->next;
                free(prev);
                return book;
            }
            prev->next = book->next;
            free(book);                     // free():释放资源
            printf("已将旧书处理掉!\n");
            printf("按任意键返回\n");
            getchar();
            return book1;
        }
        prev = book;
        book = book->next;
    }
    printf("没有找到该图书\n");
    printf("按任意键返回\n");
    getchar();
    return book1;
}
//C6
void foundBook(Book* book1)
{
    Book* book = book1;
    printf("输入要查找的书的id:");
    int id;
    scanf("%d", &id);
    getchar();
    while (book != NULL)
    {
        if (id == book->iNum)
        {
            printf("该书的信息如下:\n");
            printf("%d\t%s\t%s\t%s\t%d\n", book->iNum, book->acName, book->acAuthor, book->acPress, book->iAmount);
            printf("按任意键返回\n");
            getchar();
            return;
        }
        book = book->next;
    }
    printf("没有找到该书!\n");
    printf("按任意键返回\n");
    getchar();
    return;
}
//C7
void foundReader_Info(Reader* reader1)
{
    Reader* reader = reader1; //备份
    printf("输入读者的id:");
    int id;
    scanf("%d", &id);
    getchar();
    while (reader)
    {
        if (id == reader->iNum)
        {
            printf("借阅的书的编号如下:\n");
            for (int i = 0; i < reader->iMax; i++)  //根据读者可以借阅的数量作为循环终止条件
            {
                if (reader->aiBookId[i] != 0)       //数组里不为0，证明有一条记录，因为：数组初始化为0，并且书的编号不可能为0
                {
                    printf("%d\n", reader->aiBookId[i]);
                }
            }
            printf("按任意键返回\n");
            getchar();
            return;
        }
        reader = reader->next;
    }
    printf("没有该读者!\n");
    printf("按任意键返回\n");
    getchar();
    return;
}

//C8
void foundReaderInfo(Reader* reader1)
{
    Reader* reader = reader1;
    printf("输入读者的id:");
    int id;
    scanf("%d", &id);
    getchar();
    while (reader)
    {
        if (id == reader->iNum)
        {
            printf("读者id:%d\n", reader->iNum);
            printf("读者姓名:%s\n", reader->acName);
            printf("读者性别:%s\n", reader->acSex);
            printf("读者职位:%s\n", reader->position);
            printf("读者已借阅书的数量:%d\n", reader->iAmount);
            printf("按任意键返回\n");
            getchar();
            return;
        }
        reader = reader->next;
    }
    printf("没有找到该读者\n");
    printf("按任意键返回\n");
    getchar();
    return;
}

//C9
Reader* LendBook(Reader* reader1, Book* book1)
{
    Reader* reader = reader1;
    Book* book = book1;
    Reader* prev = reader1;
    Reader* tmpp = reader1;
    printf("输入读者id:");
    int id;
    scanf("%d", &id);
    getchar();
    if (reader == NULL)
    {
        Reader* tmp = (Reader*)malloc(sizeof(Reader));
        tmp->next = NULL;
        tmp->iAmount = 0;
        tmp->iNum = id;
        printf("输入读者名字:");
        scanf("%s", &tmp->acName);
        getchar();
        printf("输入读者性别:");
        scanf("%s", &tmp->acSex);
        getchar();
        printf("输入读者职位:<student\tor\tteacher>");
        scanf("%s", &tmp->position);
        getchar();
        if (strcmp(tmp->position, "student") == 0)
        {
            tmp->iMax = 20;
            tmp->day = 30;
        }
        else {
            tmp->iMax = 40;
            tmp->day = 60;
        }
        for (int i = 0; i < tmp->iMax; i++)
        {
            tmp->aiBookId[i] = 0;
        }
        printf("输入要借的书的编号:");
        int id_book;
        scanf("%d", &id_book);
        getchar();
        while (book != NULL)
        {
            if (id_book == book->iNum)
            {
                if (book->iAmount <= 1)
                {
                    printf("借阅失败，该图书库存不足.\n");
                    printf("按任意键返回\n");
                    getchar();
                    return NULL;
                }
                if ((tmp->iAmount) + 1 > tmp->iMax)
                {
                    printf("借阅失败,该读者借阅图书数量已达上线.\n");
                    printf("按任意键返回\n");
                    getchar();
                    return NULL;
                }
                book->iAmount--;
                tmp->aiBookId[tmp->iAmount] = id_book;
                tmp->iAmount;
                reader = tmp;
                printf("借阅成功!\n");
                printf("按任意键返回\n");
                getchar();
                return reader;
            }
            book = book->next;
        }
        printf("没有找到该书!\n");
        printf("按任意键返回\n");
        getchar();
        return reader1;
    }
    if (reader != NULL)
    {
        while (reader != NULL)
        {
            if (id == reader->iNum)
            {
                printf("图使馆当前的书籍册:\n");
                ShowLibBook(book);
                printf("输入要借的书的编号:");
                int id_book;
                scanf("%d", &id_book);
                getchar();
                while (book != NULL)
                {
                    if (id_book == book->iNum)
                    {
                        if (book->iAmount <= 1)
                        {
                            printf("借阅失败，该图书库存不足.\n");
                            printf("按任意键返回\n");
                            getchar();
                            return reader1;
                        }
                        if (tmpp->iAmount + 1 > tmpp->iMax)
                        {
                            printf("借阅失败,该读者借阅图书数量已达上线.\n");
                            printf("按任意键返回\n");
                            getchar();
                            return reader1;
                        }
                        reader->iAmount++;
                        reader->aiBookId[tmpp->iAmount] = id_book;
                        return reader1;
                    }
                    book = book->next;
                }
                printf("没有找到该书!\n");
                printf("按任意键返回\n");
            }
            reader = reader->next;
        }
    }
}


//C10
void returnBook(Reader* reader1, Book* book1)
{
    Reader* reader = reader1;
    Book* book = book1;
    printf("请输入读者的id:");
    int id;
    scanf("%d", &id);
    getchar();
    if (reader != NULL)
    {
        while (reader != NULL)
        {
            if (id == reader->iNum)
            {
                printf("请输入要还的书的编号:");
                int id_book;
                scanf("%d", &id_book);
                getchar();
                for (int i = 0; i < reader->iMax; i++)
                {
                    if (reader->aiBookId[i] == id_book)
                    {
                        reader->aiBookId[i] = 0;
                        while (book)
                        {
                            if (id_book == book->iNum)
                            {
                                book->iAmount++;
                                printf("还书成功!\n");
                                printf("按任意键返回\n");
                                getchar();
                                return reader1;
                            }
                            book = book->next;
                        }
                    }
                }
                printf("没有找到该图书，检查图书的Id\n");
                printf("按任意键返回\n");
                getchar();
                return reader1;
            }
            reader = reader->next;
        }
        printf("没有找到该读者，检查读者id是否输入有误\n");
        printf("按任意键返回\n");
        getchar();
        return reader1;
    }
}

//C11
void save(Book* book1)
{
    FILE* fp;
    Book* pCur = book1;
    int iCount = 0;
    if (pCur == NULL)
    {
        printf("\n没有学生记录!\n");
        return;
    }
    if ((fp = fopen("book.txt", "wb")) == NULL)
    {
        printf("创建文件失败!\n");
        getchar();
        exit(1);
    }
    while (pCur)
    {
        fwrite(pCur, sizeof(Book), 1, fp);
        pCur = pCur->next;
        iCount++;
    }
    printf("\n");
    printf("保存文件的数据数目为:%d\n", iCount);
    fclose(fp);
}
//C12
Book* read1()
{
    FILE* fp;
    Book* pHead = NULL, * pTemp = NULL, * pCur = NULL;
    if ((fp = fopen("book.txt", "r")) == NULL)
    {
        printf("\n文件打开失败!请检查文件名!\n");
        exit(0);
    }
    pTemp = (Book*)malloc(sizeof(Book));
    while (fread(pTemp, sizeof(Book), 1, fp))
    {
        if (!pHead)
        {
            pHead = pCur = pTemp;
        }
        else
        {
            pCur->next = pTemp;
            pCur = pTemp;
        }
        pTemp = (Book*)malloc(sizeof(Book));
    }
    fclose(fp);
    return pHead;
}